import { FunnelStage, FunnelStageListDocument } from '../API';
import { CRUDService, ICrudService, ServiceQueryHookOptions } from '../core';
export declare class FunnelStageService extends CRUDService<FunnelStage> {
    protected hasOneModels: ICrudService<FunnelStage>['hasOneModels'];
    validateName: (name: string, funnelID: string) => Promise<boolean>;
    get readById(): (id: string) => never;
    get useIsAllConditionsConfigured(): (funnelID: string, options?: Omit<ServiceQueryHookOptions<typeof FunnelStageListDocument>, 'variables'>) => {
        isAllConditionsConfigured: boolean;
        notConfiguredFunnelStage: {
            __typename?: "FunnelStage";
            id: string;
            name?: string;
            order?: number;
            condition?: any[][];
            description?: string;
            conditionSet?: boolean;
            useForCompletion?: boolean;
        };
        isLoading: boolean;
    };
    get useLastStepForCompletion(): (funnelID: string, options?: Omit<ServiceQueryHookOptions<typeof FunnelStageListDocument>, 'variables'>) => {
        lastStepForCompletion: {
            __typename?: "FunnelStage";
            id: string;
            name?: string;
            order?: number;
            condition?: any[][];
            description?: string;
            conditionSet?: boolean;
            useForCompletion?: boolean;
        };
        hasAtLeastOneStepForCompletion: boolean;
        isLoading: boolean;
    };
    get create(): (input: Partial<Record<"accounts" | "users" | "opportunities" | "leads", import("../../..").ModelWithId[]> & Record<import("../core").HasOneRelationsOf<FunnelStage>, import("../../..").ModelWithId>> & Omit<import("../API").CreateFunnelStage, "accounts" | "users" | "opportunities" | "leads" | import("../core").HasOneRelationsOf<FunnelStage>>, options?: import("../core").MutationOptionsWithoutMutation<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageCreateOneMutation, import("../API").Exact<{
        input: import("../API").CreateFunnelStage;
    }>>>) => Promise<{
        __typename?: "FunnelStage";
        id: string;
        name?: string;
        order?: number;
        condition?: any[][];
        description?: string;
        conditionSet?: boolean;
        useForCompletion?: boolean;
    }>;
    get useCreate(): (options?: import("../core").CacheUpdateOptions<import("../core").ServiceMutationHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageCreateOneMutation, import("../API").Exact<{
        input: import("../API").CreateFunnelStage;
    }>>>>) => [(payload: import("../core").InputAndRelations<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageCreateOneMutation, import("../API").Exact<{
        input: import("../API").CreateFunnelStage;
    }>>, FunnelStage>) => Promise<{
        __typename?: "FunnelStage";
        id: string;
        name?: string;
        order?: number;
        condition?: any[][];
        description?: string;
        conditionSet?: boolean;
        useForCompletion?: boolean;
    }>, import("@apollo/client").MutationResult<{
        createOne: import("../../..").ModelWithId;
    }>];
    get update(): (input: Partial<Record<"accounts" | "users" | "opportunities" | "leads", import("../../..").ModelWithId[]> & Record<import("../core").HasOneRelationsOf<FunnelStage>, import("../../..").ModelWithId>> & Omit<import("../API").UpdateFunnelStage, "accounts" | "users" | "opportunities" | "leads" | import("../core").HasOneRelationsOf<FunnelStage>> & {
        id: string;
    }, options?: import("../core").MutationOptionsWithoutMutation<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageUpdateOneMutation, import("../API").Exact<{
        input: import("../API").UpdateOneFunnelStageInput;
    }>>>) => Promise<{
        __typename?: "FunnelStage";
        id: string;
        name?: string;
        order?: number;
        condition?: any[][];
        description?: string;
        conditionSet?: boolean;
        useForCompletion?: boolean;
    }>;
    get useUpdate(): (mainOptions?: import("../core").CacheUpdateOptions<import("../core").ServiceMutationHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageUpdateOneMutation, import("../API").Exact<{
        input: import("../API").UpdateOneFunnelStageInput;
    }>>>>) => [({ id, ...input }: Partial<Record<"accounts" | "users" | "opportunities" | "leads", import("../../..").ModelWithId[]> & Record<import("../core").HasOneRelationsOf<FunnelStage>, import("../../..").ModelWithId>> & import("../API").UpdateFunnelStage & {
        id: string;
    }, options?: import("../core").CacheUpdateOptions<import("../core").ServiceMutationHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageUpdateOneMutation, import("../API").Exact<{
        input: import("../API").UpdateOneFunnelStageInput;
    }>>>>) => Promise<Record<string, unknown>>, import("@apollo/client").MutationResult<{
        updateOne: Record<string, unknown>;
    }>];
    get delete(): (id: string, options?: import("../core").MutationOptionsWithoutMutation<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageDeleteOneMutation, import("../API").Exact<{
        input: import("../API").DeleteOneFunnelStageInput;
    }>>>) => Promise<{
        __typename?: "FunnelStageDeleteResponse";
        id?: string;
    }>;
    get useDelete(): (options?: import("../core").ServiceMutationHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageDeleteOneMutation, import("../API").Exact<{
        input: import("../API").DeleteOneFunnelStageInput;
    }>>>) => [(id?: string) => Promise<{
        __typename?: "FunnelStageDeleteResponse";
        id?: string;
    }>, import("@apollo/client").MutationResult<import("../API").FunnelStageDeleteOneMutation>];
    get list(): (input: import("../API").Exact<{
        filter?: import("../API").FunnelStageFilter;
        sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
        paging?: import("../API").CursorPaging;
    }>, options?: import("../core").ServiceQueryOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageListQuery, import("../API").Exact<{
        filter?: import("../API").FunnelStageFilter;
        sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
        paging?: import("../API").CursorPaging;
    }>>>) => Promise<{
        __typename?: "FunnelStageConnection";
        totalCount: number;
        edges: {
            __typename?: "FunnelStageEdge";
            cursor: any;
            node: {
                __typename?: "FunnelStage";
                id: string;
                name?: string;
                order?: number;
                condition?: any[][];
                description?: string;
                conditionSet?: boolean;
                useForCompletion?: boolean;
            };
        }[];
        pageInfo: {
            __typename?: "PageInfo";
            endCursor?: any;
            startCursor?: any;
            hasNextPage?: boolean;
            hasPreviousPage?: boolean;
        };
    }>;
    get useList(): (options: import("../core").CacheUpdateOptions<ServiceQueryHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageListQuery, import("../API").Exact<{
        filter?: import("../API").FunnelStageFilter;
        sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
        paging?: import("../API").CursorPaging;
    }>>>>) => {
        isLoading: boolean;
        isRefetching: boolean;
        hasMore: any;
        refetching: boolean;
        client: import("@apollo/client").ApolloClient<any>;
        observable: import("@apollo/client").ObservableQuery<import("../API").FunnelStageListQuery, import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>;
        data: import("../API").FunnelStageListQuery;
        previousData?: import("../API").FunnelStageListQuery;
        error?: import("@apollo/client").ApolloError;
        errors?: readonly import("graphql").GraphQLFormattedError[];
        loading: boolean;
        networkStatus: import("@apollo/client").NetworkStatus;
        called: boolean;
        startPolling: (pollInterval: number) => void;
        stopPolling: () => void;
        subscribeToMore: <TSubscriptionData = import("../API").FunnelStageListQuery, TSubscriptionVariables extends import("@apollo/client").OperationVariables = import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>(options: import("@apollo/client").SubscribeToMoreOptions<import("../API").FunnelStageListQuery, TSubscriptionVariables, TSubscriptionData>) => () => void;
        updateQuery: <TVars extends import("@apollo/client").OperationVariables = import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>(mapFn: (previousQueryResult: import("../API").FunnelStageListQuery, options: Pick<import("@apollo/client").WatchQueryOptions<TVars, import("../API").FunnelStageListQuery>, "variables">) => import("../API").FunnelStageListQuery) => void;
        refetch: (variables?: Partial<import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").FunnelStageListQuery>>;
        reobserve: (newOptions?: Partial<import("@apollo/client").WatchQueryOptions<import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>, import("../API").FunnelStageListQuery>>, newNetworkStatus?: import("@apollo/client").NetworkStatus) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").FunnelStageListQuery>>;
        variables: import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>;
        fetchMore: <TFetchData = import("../API").FunnelStageListQuery, TFetchVars extends import("@apollo/client").OperationVariables = import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>(fetchMoreOptions: import("@apollo/client").FetchMoreQueryOptions<TFetchVars, TFetchData> & {
            updateQuery?: (previousQueryResult: import("../API").FunnelStageListQuery, options: {
                fetchMoreResult: TFetchData;
                variables: TFetchVars;
            }) => import("../API").FunnelStageListQuery;
        }) => Promise<import("@apollo/client").ApolloQueryResult<TFetchData>>;
    };
    get useBreakdownList(): (options: import("../core").CacheUpdateOptions<ServiceQueryHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageBreakdownListQuery, import("../API").Exact<{
        filter?: import("../API").FunnelStageFilter;
        sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
        paging?: import("../API").CursorPaging;
    }>>>>) => {
        isLoading: boolean;
        isRefetching: boolean;
        hasMore: any;
        refetching: boolean;
        client: import("@apollo/client").ApolloClient<any>;
        observable: import("@apollo/client").ObservableQuery<import("../API").FunnelStageBreakdownListQuery, import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>;
        data: import("../API").FunnelStageBreakdownListQuery;
        previousData?: import("../API").FunnelStageBreakdownListQuery;
        error?: import("@apollo/client").ApolloError;
        errors?: readonly import("graphql").GraphQLFormattedError[];
        loading: boolean;
        networkStatus: import("@apollo/client").NetworkStatus;
        called: boolean;
        startPolling: (pollInterval: number) => void;
        stopPolling: () => void;
        subscribeToMore: <TSubscriptionData = import("../API").FunnelStageBreakdownListQuery, TSubscriptionVariables extends import("@apollo/client").OperationVariables = import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>(options: import("@apollo/client").SubscribeToMoreOptions<import("../API").FunnelStageBreakdownListQuery, TSubscriptionVariables, TSubscriptionData>) => () => void;
        updateQuery: <TVars extends import("@apollo/client").OperationVariables = import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>(mapFn: (previousQueryResult: import("../API").FunnelStageBreakdownListQuery, options: Pick<import("@apollo/client").WatchQueryOptions<TVars, import("../API").FunnelStageBreakdownListQuery>, "variables">) => import("../API").FunnelStageBreakdownListQuery) => void;
        refetch: (variables?: Partial<import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").FunnelStageBreakdownListQuery>>;
        reobserve: (newOptions?: Partial<import("@apollo/client").WatchQueryOptions<import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>, import("../API").FunnelStageBreakdownListQuery>>, newNetworkStatus?: import("@apollo/client").NetworkStatus) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").FunnelStageBreakdownListQuery>>;
        variables: import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>;
        fetchMore: <TFetchData = import("../API").FunnelStageBreakdownListQuery, TFetchVars extends import("@apollo/client").OperationVariables = import("../API").Exact<{
            filter?: import("../API").FunnelStageFilter;
            sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
            paging?: import("../API").CursorPaging;
        }>>(fetchMoreOptions: import("@apollo/client").FetchMoreQueryOptions<TFetchVars, TFetchData> & {
            updateQuery?: (previousQueryResult: import("../API").FunnelStageBreakdownListQuery, options: {
                fetchMoreResult: TFetchData;
                variables: TFetchVars;
            }) => import("../API").FunnelStageBreakdownListQuery;
        }) => Promise<import("@apollo/client").ApolloQueryResult<TFetchData>>;
    };
    get useGetLazy(): (options?: import("../core").CacheUpdateOptions<import("../core").ServiceLazyQueryHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").FunnelStageListQuery, import("../API").Exact<{
        filter?: import("../API").FunnelStageFilter;
        sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
        paging?: import("../API").CursorPaging;
    }>>>>) => import("@apollo/client").LazyQueryResultTuple<import("../API").FunnelStageListQuery, import("../API").Exact<{
        filter?: import("../API").FunnelStageFilter;
        sorting?: import("../API").FunnelStageSort | import("../API").FunnelStageSort[];
        paging?: import("../API").CursorPaging;
    }>>;
    get get(): (id: string, options?: Omit<import("@apollo/client").QueryOptions<import("../API").Exact<{
        id: string;
    }>, import("../API").GetFunnelStageQuery>, "query">) => Promise<{
        __typename?: "FunnelStage";
        id: string;
        name?: string;
        order?: number;
        condition?: any[][];
        description?: string;
        conditionSet?: boolean;
        useForCompletion?: boolean;
        funnel?: {
            __typename?: "Funnel";
            id: string;
            name?: string;
            status?: import("../API").SegmentStatus;
        };
    }>;
    get useGet(): (options: ServiceQueryHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").GetFunnelStageQuery, import("../API").Exact<{
        id: string;
    }>>>) => {
        isLoading: boolean;
        isRefetching: boolean;
        hasMore: any;
        refetching: boolean;
        client: import("@apollo/client").ApolloClient<any>;
        observable: import("@apollo/client").ObservableQuery<import("../API").GetFunnelStageQuery, import("../API").Exact<{
            id: string;
        }>>;
        data: import("../API").GetFunnelStageQuery;
        previousData?: import("../API").GetFunnelStageQuery;
        error?: import("@apollo/client").ApolloError;
        errors?: readonly import("graphql").GraphQLFormattedError[];
        loading: boolean;
        networkStatus: import("@apollo/client").NetworkStatus;
        called: boolean;
        startPolling: (pollInterval: number) => void;
        stopPolling: () => void;
        subscribeToMore: <TSubscriptionData = import("../API").GetFunnelStageQuery, TSubscriptionVariables extends import("@apollo/client").OperationVariables = import("../API").Exact<{
            id: string;
        }>>(options: import("@apollo/client").SubscribeToMoreOptions<import("../API").GetFunnelStageQuery, TSubscriptionVariables, TSubscriptionData>) => () => void;
        updateQuery: <TVars extends import("@apollo/client").OperationVariables = import("../API").Exact<{
            id: string;
        }>>(mapFn: (previousQueryResult: import("../API").GetFunnelStageQuery, options: Pick<import("@apollo/client").WatchQueryOptions<TVars, import("../API").GetFunnelStageQuery>, "variables">) => import("../API").GetFunnelStageQuery) => void;
        refetch: (variables?: Partial<import("../API").Exact<{
            id: string;
        }>>) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").GetFunnelStageQuery>>;
        reobserve: (newOptions?: Partial<import("@apollo/client").WatchQueryOptions<import("../API").Exact<{
            id: string;
        }>, import("../API").GetFunnelStageQuery>>, newNetworkStatus?: import("@apollo/client").NetworkStatus) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").GetFunnelStageQuery>>;
        variables: import("../API").Exact<{
            id: string;
        }>;
        fetchMore: <TFetchData = import("../API").GetFunnelStageQuery, TFetchVars extends import("@apollo/client").OperationVariables = import("../API").Exact<{
            id: string;
        }>>(fetchMoreOptions: import("@apollo/client").FetchMoreQueryOptions<TFetchVars, TFetchData> & {
            updateQuery?: (previousQueryResult: import("../API").GetFunnelStageQuery, options: {
                fetchMoreResult: TFetchData;
                variables: TFetchVars;
            }) => import("../API").GetFunnelStageQuery;
        }) => Promise<import("@apollo/client").ApolloQueryResult<TFetchData>>;
    };
}
